#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "globals.h"
#include <alloc.h>

ffblk Entrie;
cbits bgiven;
dirinfo DInfo = {0,0,"","","","","","",'\4','\0'} ;
tdata tscreen;
file_list *flist;
unsigned TList = 0;
unsigned TRows = 0;

int main(int argc, char* argv[]) {

	int er = 0, i = 0;
	unsigned LRow = 0, FRow = 0, ln = 0, c = 0;
	char k = '\0';
	char *cntr;
	char *line;
	char *ptr;

	ptr = getenv("FINAL-D");

	if (ptr != NULL) {
		while (ptr[ln] != '\0')
			if ((ptr[ln] > 96) && (ptr[ln] < 123)) ptr[ln++] -= 32;
			else ++ln;
		ParseEnv(ptr);
	}

	for (i = 1; i < argc; i++) {
		ln = 0;
		while (argv[i][ln] != '\0') {if ((argv[i][ln] > 96) && (argv[i][ln] < 123)) argv[i][ln] -= 32;++ln;}
		if ((argv[i][0] != '/') && (argv[i][0] != '-')) {
			if (!(bgiven.cflags & 512)) {
				ln = 0;
				bgiven.cflags |= 512;
				while ((argv[i][ln] != '\0') && (ln < _MAX_PATH)) DInfo.Path[ln] = argv[i][ln++];
				if (ln == _MAX_PATH) {showerr(-9);return(-9);}
			}
		} else {
			er = getswitch(argv[i]);
			if (er == 1) c = 1;
			if ((er < 0) && (c !=1)) c = 2;
		}
	}

	er = getcur();
	if (er < 0) {showerr(er);return(er);}

	if (c == 1) {
		showhelp();
		return(0);
	}
	if (c == 2) {
		showerr(-3);
		return(-3);
	}

	c = 0;
	while (c == 0) {
		c = tscreen.columns / DInfo.Columns;
		if (c < 13) {--DInfo.Columns;c = 0;}
		if (DInfo.Columns == 0) {showerr(-8);return(-8);}
		
	}
	if (c > 19) bgiven.display |= 1;
	if (c > 34) bgiven.display |= 4;
	if ((c > 50) && !(bgiven.sname)) bgiven.display |= 8;
	if ((c > 24) && (c < 35)) bgiven.display |= 2;
	if ((c > 39) && ((c < 51) || (bgiven.sname))) bgiven.display |= 2;
	if (c > 55) bgiven.display |= 2;

	if (bgiven.dclear) sclear();

	line = (char *)calloc((tscreen.columns + 1),1);
	if (line == NULL) {showerr(-8);return(-8);}

	er = cleanpath(DInfo.Path);
	if (er < 0) {showerr(er);free(line);return(er);}

	er = getdirinfo();
	if (er < 0) {showerr(er);free(line);return(er);}

	TList = DInfo.TFiles + DInfo.TDirectories;

	TRows = TList / DInfo.Columns;
	if ((TList % DInfo.Columns) != 0) ++TRows;
	TRows += 4;

	if (TList == 0) {
		DInfo.Columns = 1;
		ShowNoFiles(line);
		free(line);
		return(0);
	}

	cntr = (char *)calloc(((tscreen.columns / 2) - 5),1);
	if(cntr == NULL) {showerr(-8);free(line);return(-8);}
	for(ln = 0; ln < (unsigned(tscreen.columns / 2) - 6); ln++)
		cntr[ln] = ' ';
	cntr[ln] = '\0';

	flist = (file_list *)calloc(TList,sizeof(file_list));
	if (flist == NULL) {showerr(-7);free(cntr);free(line);return(-7);}

	er = getlist();
	if (er < 0) {showerr(er);free(flist);free(cntr);free(line);return(er);}

	if (((bgiven.dplace & 3) < 2) || ((bgiven.sort & 7) > 0) || (bgiven.reverse))
		sortlist();

	if ((TRows < (tscreen.rows -2)) || (bgiven.dbrowse)) LRow = TRows;
		else LRow = (tscreen.rows - 2);
	FRow = 0;

	scurs(0);

	c_print("\r");
	ShowLine(FRow,line);
	for (ln = (FRow + 1); ln <= LRow; ln++) {
		c_print("\n");
		ShowLine(ln,line);
	}

	if (LRow != TRows) {
		c_print("\n");
		tcolor(WHITE);
		c_print(cntr);
		c_print("<Browsing>\r");
		tcolor(tscreen.Oattrib);
	}

	while (LRow < TRows) {
		k = readkey();
		if (k == EscKey) {
			ClearLine();
			tcolor(YELLOW);
			c_print(cntr);
			c_print("<Cancelled>");
			LRow = TRows;
		}
		if ((k == EnterKey) || (k == SpaceKey)) {
			ClearLine();
			FRow = LRow + 1;
			LRow += (tscreen.rows - 1);
			if (LRow > TRows) LRow = TRows;
			for (c = FRow; c < LRow; c++) {
				ShowLine(c,line);
				c_print("\n");
			}
			if (LRow < TRows) {
				--LRow;
				tcolor(WHITE);
				c_print(cntr);
				c_print("<Browsing>\r");
			}
		}
		if ((k == PageDownKey) && (LRow < (TRows - 1))) {
			if ((LRow + (tscreen.rows - 1)) > (TRows - 1))
				c = TRows - 1 - LRow;
			else c = (tscreen.rows - 1);
			for (ln = 0; ln < c; ln++) {
				scrlfor();
				ShowLine(++LRow,line);
			}
			FRow = LRow - (tscreen.rows - 2);
			lastrow();
		}
		if ((k == DownKey) && (LRow < (TRows - 1))) {
			scrlfor();
			ShowLine(++LRow,line);
			lastrow();
		}
		if ((k == UpKey) && (LRow > (tscreen.rows - 2))) {
			--LRow;
			FRow = LRow - (tscreen.rows - 2);
			scrlback();
			ShowLine(FRow,line);
			lastrow();
		}
		if ((k == PageUpKey) && (LRow > (tscreen.rows - 2))) {
			if (LRow > ((tscreen.rows * 2) - 3)) c = (tscreen.rows - 1);
				else c = LRow - (tscreen.rows - 2);
			for (ln = 0; ln < c; ln++) {
				--LRow;
				FRow = LRow - (tscreen.rows - 2);
				scrlback();
				ShowLine(FRow,line);
			}
			lastrow();
		}
	}

	scurs(1);

	free(flist);
	free(cntr);
	free(line);

	return(0);
}
