#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include "globals.h"

char commands[] = "?H123456789ODRLMCBAS";

char readkey(void) {

	char kb = 0;

	while ((kb != UpKey) && (kb != DownKey) & (kb != PageUpKey) && (kb != PageDownKey) \
		&& (kb != SpaceKey) && (kb != EnterKey) && (kb != EscKey)) {
		kbhit();
		kb = getch();
		if ((kb == UpKey) || (kb == DownKey) || (kb == PageUpKey) || (kb == PageDownKey))
			kb = 1;
		if (kb == 0) kb = getch();
	}

	return(kb);
}

void ParseEnv(char *env) {

	char chk[2] = " ";
	char *cpoint;
	unsigned i = 0, c = 0;
	int n = 0;

	while (env[i] != '\0') {
		if ((env[i] == '/') || (env[i] == '-')) {
			++i;
			chk[0] = env[i];
			cpoint = strpbrk(commands,chk);
			if (cpoint != NULL) {
				if ((cpoint - commands) > 0) --cpoint;
				if (((cpoint - commands) > 0) && ((cpoint - commands) < 10)) cpoint = commands + 1;
				if ((cpoint - commands) > 9) cpoint -= 8;
				switch (cpoint - commands) {
					case 0: break;
					case 1: if (bgiven.cflags & 32) {++i;break;}
						bgiven.cflags |= 32;
						n = env[i++] - '0';
						while ((n >= 0) && (n < 10)) {
							c *= 10;
							c += n;
							n = env[i++] - '0';
						}
						if (c > 255) c = 255;
						if (c < 1) c = 4;
						DInfo.Columns = c;
						break;
					case 2: ++i; if (bgiven.cflags & 1) break;
						bgiven.cflags |= 1;
						chk[0] = env[i];
						if (chk[0] == '-')
							bgiven.sort = 0;
						if (chk[0] == 'N')
							bgiven.sort = 1;
						if (chk[0] == 'E')
							bgiven.sort = 2;
						if (chk[0] == 'S')
							bgiven.sort = 3;
						if (chk[0] == 'D')
							bgiven.sort = 4;
						++i;break;
					case 3: ++i; if (bgiven.cflags & 2) break;
						bgiven.cflags |= 2;
						chk[0] = env[i];
						if (chk[0] == 'F')
							bgiven.dplace = 0;
						if (chk[0] == 'L')
							bgiven.dplace = 1;
						if (chk[0] == 'M')
							bgiven.dplace = 2;
						if (chk[0] == '-')
							bgiven.dplace = 3;
						++i;break;
					case 4: if (bgiven.cflags & 4) break;
						bgiven.cflags |= 4;
						bgiven.reverse = 1; ++i;break;
					case 5: if (bgiven.cflags & 8) break;
						bgiven.cflags |= 8;
						bgiven.dformat = 1; ++i;break;
					case 6: if (bgiven.cflags & 16) break;
						bgiven.cflags |= 16;
						bgiven.dcolor = 1; ++i;break;
					case 7: if (bgiven.cflags & 64) break;
						bgiven.cflags |= 64;
						bgiven.dclear = 1; ++i;break;
					case 8: if (bgiven.cflags & 128) break;
						bgiven.cflags |= 128;
						bgiven.dbrowse = 1; ++i;break;
					case 9: if (bgiven.cflags & 256) break;
						bgiven.cflags |= 256;
						bgiven.dansi = 1; ++i;break;
					case 10: if (bgiven.cflags & 1024) break;
						bgiven.cflags |= 1024;
						bgiven.sname = 1; ++i;break;
				}
			}
		} else ++i;
	}
	bgiven.cflags = 0;

	return;
}

int getswitch(char *argv) {

	char *cpoint;
	char tst[2] = " ";
	unsigned c = 0, i = 0;
	int n = 0;

	tst[0] = argv[1];
	cpoint = strpbrk(commands,tst);
	if (cpoint != NULL) {
		if ((cpoint - commands) > 0) --cpoint;
		if (((cpoint - commands) > 0) && ((cpoint - commands) < 10)) cpoint = commands + 1;
		if ((cpoint - commands) > 9) cpoint -= 8;
		switch (cpoint - commands) {
			case 0: return(1);
			case 1: if (bgiven.cflags & 32) return(0);
				bgiven.cflags |= 32;
				i = 2;
				n = argv[1] - '0';
				while ((n >= 0) && (n < 10)) {
					c *= 10;
					c += n;
					n = argv[i++] - '0';
				}
				if (c > 255) c = 255;
				if (c < 1) c = 4;
				DInfo.Columns = c;
				return(0);
			case 2: if (bgiven.cflags & 1) return(0);
				if (argv[2] == '-') {
					bgiven.sort = 0;
					bgiven.cflags |= 1;
					return(0);
				}
				if (argv[2] == 'N') {
					bgiven.sort = 1;
					bgiven.cflags |= 1;
					return(0);
				}
				if (argv[2] == 'E') {
					bgiven.sort = 2;
					bgiven.cflags |= 1;
					return(0);
				}
				if (argv[2] == 'S') {
					bgiven.sort = 3;
					bgiven.cflags |= 1;
					return(0);
				}
				if (argv[2] == 'D') {
					bgiven.sort = 4;
					bgiven.cflags |= 1;
					return(0);
				}
				break;
			case 3: if (bgiven.cflags & 2) return(0);
				if (argv[2] == 'F') {
					bgiven.dplace = 0;
					bgiven.cflags |= 2;
					return(0);
				}
				if (argv[2] == 'L') {
					bgiven.dplace = 1;
					bgiven.cflags |= 2;
					return(0);
				}
				if (argv[2] == 'M') {
					bgiven.dplace = 2;
					bgiven.cflags |= 2;
					return(0);
				}
				if (argv[2] == '-') {
					bgiven.dplace = 3;
					bgiven.cflags |= 2;
					return(0);
				}
				break;
			case 4: if (bgiven.cflags & 4) return(0);
				bgiven.reverse = 1;
				bgiven.cflags |= 4;
				return(0);
			case 5: if (bgiven.cflags & 8) return(0);
				bgiven.dformat = 1;
				bgiven.cflags |= 8;
				return(0);
			case 6: if (bgiven.cflags & 16) return(0);
				bgiven.dcolor = 1;
				bgiven.cflags |= 16;
				return(0);
			case 7: if (bgiven.cflags & 64) return(0);
				bgiven.dclear = 1;
				bgiven.cflags |= 64;
				return(0);
			case 8: if (bgiven.cflags & 128) return(0);
				bgiven.dbrowse = 1;
				bgiven.cflags |= 128;
				return(0);
			case 9: if (bgiven.cflags & 256) return(0);
				bgiven.dansi = 1;
				bgiven.cflags |= 256;
				return(0);
			case 10: if (bgiven.cflags & 1024) return(0);
				bgiven.cflags |= 1024;
				bgiven.sname = 1;
				return(0);
		}
	}
	return(-3);
}

void ShowLine(unsigned ln,char *line) {

	unsigned i = 0, c = 0, x = 12, y = 0, len = 0, b = 0;
	unsigned const z = (TList % DInfo.Columns);
	char tem[7] = "", tz[4] = " am", isdir[8] = "  <DIR>";
	const char mnth[12][11] = {"   January","  February","     March","     April","       May",
		"      June","      July","    August"," September","   October","  November","  December"};

	if (bgiven.display & 1) x += 7;
	if (bgiven.display & 2) x += 5;
	if (bgiven.display & 4) {
		if (bgiven.display & 8) x += 31;
		else x += 15;
	}

	len = (tscreen.columns / DInfo.Columns) - 1;

	if (ln == 0) {
		tcolor(CYAN);
		for (c = 1; c <= DInfo.Columns; c++) {
			for (i = 0; i < len; i++)
				line[((c - 1) * (len + 1)) + i] = '\xc4';
			if (c < DInfo.Columns) line[((c - 1) * (len + 1)) + i] = '\xc2';
		}
		for (c = ((DInfo.Columns * (len + 1)) - 1); c < (tscreen.columns - 1); c++)
			line[c] = '\xc4';
		line[c] = '\0';
		c_print(line);
	}
	if (ln == (TRows - 3)) {
		tcolor(CYAN);
		for (c = 1; c <= DInfo.Columns; c++) {
			for (i = 0; i < len; i++)
				line[((c - 1) * (len + 1)) + i] = '\xc4';
			if (c < DInfo.Columns) line[((c - 1) * (len + 1)) + i] = '\xc1';
		}
		for (c = ((DInfo.Columns * (len + 1)) - 1); c < (tscreen.columns - 1); c++)
			line[c] = '\xc4';
		line[c] = '\0';
		c_print(line);
	}
	if (ln == (TRows - 2)) {
		if (tscreen.columns < 20) {
			tcolor(LIGHTCYAN);
			for (i = 0; i < (((tscreen.columns - 1) / 2) - 6); i++)
				line[i] = ' ';
			if (TList > 9999) line[i++] = (b / 10000) + '0';
			else line[i++] = ' ';
			b %= 10000;
			if (TList > 999) line[i++] = (b / 1000) + '0';
			b %= 1000;
			if (TList > 99) line[i++] = (b / 100) + '0';
			else line[i++] = ' ';
			b %= 100;
			if (TList > 9) line[i++] = (b / 10) + '0';
			line[i++] = (b % 10) + '0';
			line[i] = '\0';
			c_print(line);
			tcolor(CYAN);
			c_print(" Files");
		} else if (tscreen.columns < 40) {
			tcolor(LIGHTCYAN);
			for (i = 0; i < (((tscreen.columns - 1) / 2) - 9); i++)
				line[i] = ' ';
			if (TList > 9999) line[i++] = (b / 10000) + '0';
			else line[i++] = ' ';
			b %= 10000;
			if (TList > 999) line[i++] = (b / 1000) + '0';
			b %= 1000;
			if (TList > 99) line[i++] = (b / 100) + '0';
			else line[i++] = ' ';
			b %= 100;
			if (TList > 9) line[i++] = (b / 10) + '0';
			line[i++] = (b % 10) + '0';
			line[i] = '\0';
			c_print(line);
			tcolor(CYAN);
			c_print(" Files ");
			tcolor(LIGHTCYAN);
			c_print(DInfo.TBytes);
		} else if (tscreen.columns < 60) {
			tcolor(LIGHTCYAN);
			for (i = 0; i < (((tscreen.columns - 1) / 2) - 18); i++)
				line[i] = ' ';
			if (TList > 9999) line[i++] = (b / 10000) + '0';
			else line[i++] = ' ';
			b %= 10000;
			if (TList > 999) line[i++] = (b / 1000) + '0';
			b %= 1000;
			if (TList > 99) line[i++] = (b / 100) + '0';
			else line[i++] = ' ';
			b %= 100;
			if (TList > 9) line[i++] = (b / 10) + '0';
			line[i++] = (b % 10) + '0';
			line[i] = '\0';
			c_print(line);
			tcolor(CYAN);
			c_print(" Files with ");
			tcolor(LIGHTCYAN);
			c_print(DInfo.TBytes);
			tcolor(CYAN);
			c_print(" Using ");
			tcolor(LIGHTCYAN);
			c_print(DInfo.UBytes);
		} else if (tscreen.columns < 80) {
			tcolor(LIGHTCYAN);
			for (i = 0; i < (((tscreen.columns - 1) / 2) - 28); i++)
				line[i] = ' ';
			if (TList > 9999) line[i++] = (b / 10000) + '0';
			else line[i++] = ' ';
			b %= 10000;
			if (TList > 999) line[i++] = (b / 1000) + '0';
			b %= 1000;
			if (TList > 99) line[i++] = (b / 100) + '0';
			else line[i++] = ' ';
			b %= 100;
			if (TList > 9) line[i++] = (b / 10) + '0';
			line[i++] = (b % 10) + '0';
			line[i] = '\0';
			c_print(line);
			tcolor(CYAN);
			c_print(" Files with ");
			tcolor(LIGHTCYAN);
			c_print(DInfo.TBytes);
			tcolor(CYAN);
			c_print(" Using ");
			tcolor(LIGHTCYAN);
			c_print(DInfo.UBytes);
			tcolor(CYAN);
			c_print(" of Disk Space");
		} else {
			tcolor(LIGHTCYAN);
			for (i = 0; i < (((tscreen.columns - 1) / 2) - 38); i++)
				line[i] = ' ';
			b = 9;
			if (DInfo.TFiles > 9999) --b;
			if (DInfo.TFiles > 999) --b;
			if (DInfo.TFiles > 99) --b;
			if (DInfo.TFiles > 9) --b;
			--b;
			if (DInfo.TDirectories > 9999) --b;
			if (DInfo.TDirectories > 999) --b;
			if (DInfo.TDirectories > 99) --b;
			if (DInfo.TDirectories > 9) --b;
			for (y = 0; y < (b / 2); y++) line[i++] = ' ';
			if (DInfo.TFiles > 9999) line[i++] = char(DInfo.TFiles / 10000) + '0';
			b = DInfo.TFiles % 10000;
			if (DInfo.TFiles > 999) line[i++] = (b / 1000) + '0';
			b %= 1000;
			if (DInfo.TFiles > 99) line[i++] = (b / 100) + '0';
			b %= 100;
			if (DInfo.TFiles > 9) line[i++] = (b / 10) + '0';
			line[i++] = (b % 10) + '0';
			line[i] = '\0';
			c_print(line);
			tcolor(CYAN);
			c_print(" Files & ");
			tcolor(LIGHTCYAN);
			i = 0;
			if (DInfo.TDirectories > 9999) line[i++] = char(DInfo.TDirectories / 10000) + '0';
			b = DInfo.TDirectories % 10000;
			if (DInfo.TDirectories > 999) line[i++] = (b / 1000) + '0';
			b %= 1000;
			if (DInfo.TDirectories > 99) line[i++] = (b / 100) + '0';
			b %= 100;
			if (DInfo.TDirectories > 9) line[i++] = (b / 10) + '0';
			line[i++] = (b % 10) + '0';
			line[i] = '\0';
			c_print(line);
			tcolor(CYAN);
			c_print(" Directories Totaling ");
			tcolor(LIGHTCYAN);
			c_print(DInfo.TBytes);
			tcolor(CYAN);
			c_print(" Using ");
			tcolor(LIGHTCYAN);
			c_print(DInfo.UBytes);
			tcolor(CYAN);
			c_print(" Disk Space");
		}
	}
	if (ln == (TRows - 1)) {			//26  6-on-2,
		tem[0] = DInfo.Path[0];
		tem[1] = DInfo.Path[1];
		tem[2] = '\0';
		if (tscreen.columns < 20) {
			for (i = 0; i < (((tscreen.columns - 1) / 2) - 6); i++)
				line[i] = ' ';
			line[i] = '\0';
			if (i > 0) c_print(line);
			tcolor(LIGHTCYAN);
			c_print(DInfo.DriveFree);
			tcolor(CYAN);
			c_print(" on ");
			tcolor(LIGHTMAGENTA);
			c_print(tem);
		} else if (tscreen.columns < 40) {
			for (i = 0; i < (((tscreen.columns - 1) / 2) - 8); i++)
				line[i] = ' ';
			line[i] = '\0';
			if (i > 0) c_print(line);
			tcolor(LIGHTCYAN);
			c_print(DInfo.DriveFree);
			tcolor(CYAN);
			c_print(" Free on ");
			tcolor(LIGHTMAGENTA);
			c_print(tem);
		} else if (tscreen.columns < 60) {
			tcolor(LIGHTCYAN);
			for (i = 0; i < (((tscreen.columns - 1) / 2) - 17); i++)
				line[i] = ' ';
			line[i] = '\0';
			if (i > 0) c_print(line);
			c_print(DInfo.DriveFree);
			tcolor(CYAN);
			c_print(" Free on ");
			tcolor(LIGHTCYAN);
			c_print(DInfo.DriveSize);
			tcolor(CYAN);
			c_print(" Drive ");
			tcolor(LIGHTMAGENTA);
			c_print(tem);
		} else if (tscreen.columns < 80) {
			for (i = 0; i < (((tscreen.columns - 1) / 2) - 29); i++)
				line[i] = ' ';
			for (y = i; y < (i + ((32 - unsigned(DInfo.LLen)) / 2)); y++)
				line[y] = ' ';
			line[y] = '\0';
			if (y > 0) c_print(line);
			tcolor(LIGHTCYAN);
			c_print(DInfo.DriveFree);
			tcolor(CYAN);
			c_print(" Free on Volume: ");
			tcolor(LIGHTRED);
			c_print(DInfo.DLabel);
		} else {
			for (i = 0; i < (((tscreen.columns - 1) / 2) - 38); i++)
				line[i] = ' ';
			for (y = i; y < (i + ((32 - unsigned(DInfo.LLen)) / 2)); y++)
				line[y] = ' ';
			line[y] = '\0';
			if (y > 0) c_print(line);
			tcolor(LIGHTCYAN);
			c_print(DInfo.DriveFree);
			tcolor(CYAN);
			c_print(" Free on ");
			tcolor(LIGHTCYAN);
			c_print(DInfo.DriveSize);
			tcolor(CYAN);
			c_print(" Drive ");
			tcolor(LIGHTMAGENTA);
			c_print(tem);
			tcolor(CYAN);
			c_print(" Volume: ");
			tcolor(LIGHTRED);
			c_print(DInfo.DLabel);
		}
	}
	if ((ln > 0) && (ln < (TRows - 3))) {
		for (c = 0; c < DInfo.Columns; c++) {
			if (bgiven.dformat & 1) i = (ln - 1) * DInfo.Columns + c;
				else if ((c < z) | (z == 0)) i = (ln - 1) + (c * (TRows - 4));
					else if (ln == (TRows - 4)) i = TList;
						else i = ((ln - 1) + (c * (TRows - 4)) - (c - z));
			if (i < TList) {
				if (flist[i].attrib & _A_SUBDIR) tcolor(LIGHTMAGENTA);
					else tcolor(gcolor(flist[i].ext));
				if ((len > x) && (DInfo.Columns > 1)) b = (len - x) - ((len - x) / 2); else b = 0;
				for (y = 0; y < b; y++)
					line[y] = ' ';
				while (flist[i].name[y - b] != '\0') {
					line[y] = flist[i].name[y - b];
					++y;
				}
				while ((y - b) < 9) line[y++] = ' ';
				b = y;
				while(flist[i].ext[y - b] != '\0') {
					line[y] = flist[i].ext[y - b];
					++y;
				}
				while ((y - b) < 3) line[y++] = ' ';
				line[y] = '\0';
				if (bgiven.display & 1) {
					if (flist[i].attrib & _A_SUBDIR) for (b = 0; b < 8; b++) line[y++] = isdir[b];
					else {
						c_print(line);
						tcolor(LIGHTCYAN);
						if (flist[i].size > 999999) {
							textval(tem,0,flist[i].size,6);
							line[0] = ' ';
							for (y = 1; y < 7; y++) line[y++] = tem[y - 1];
							line[y] = '\0';
						} else {
							for (y = 0; y < 7; y++) line[y] = ' ';
							line[y--] = '\0';
							b = flist[i].size;
							do {
								line[y--] = (b % 10) + '0';
								b /= 10;
							} while (b > 0);
							while (line[y] != '\0') ++y;
						}
					}
				}
				if (bgiven.display & 2) {
					c_print(line);
					y = 5;
					line[5] = '\0';line[0] = ' ';
					if (flist[i].attrib & _A_ARCH) line[1] = 'A';
						else line[1] = ' ';
					if (flist[i].attrib & _A_RDONLY) line[2] = 'R';
						else line[2] = ' ';
					if (flist[i].attrib & _A_HIDDEN) line[3] = 'H';
						else line[3] = ' ';
					if (flist[i].attrib & _A_SYSTEM) line[4] = 'S';
						else line[4] = ' ';
					tcolor(LIGHTBLUE);
				}
				if (bgiven.display & 4) {
					c_print(line);
					if (bgiven.display & 8) {
						b = (flist[i].time >> 11) & 0x001f;
						if ( b > 11) {
							b -= 12;
							tz[1] = 'p';
						}
						if (b == 0) b = 12;
						y = 0;
						line[y++] = ' ';
						if (b > 9) line[y++] = (b / 10) + '0';
						else line[y++] = ' ';
						line[y++] = (b % 10) + '0';
						line[y++] = ':';
						b = (flist[i].time >> 5) & 0x003f;
						line[y++] = (b / 10) + '0';
						line[y++] = (b % 10) + '0';
						line[y++] = ':';
						b = flist[i].time & 0x001f;
						line[y++] = (b / 5) + '0';
						line[y++] = ((b * 2) % 10) + '0';
						for (b = 0; b < 4; b++) line[y++] = tz[b];
						tcolor(LIGHTRED);
						c_print(line);
						y = 0;
						for (b = 0; b < 10; b++) line[y++] = mnth[((flist[i].date >> 5) & 0x000f) - 1][b];
						line[y++] = ' ';
						b = flist[i].date & 0x001f;
						if (b > 9) line[y++] = (b  / 10) + '0';
						else line[y++] = ' ';
						line[y++] = (b % 10) + '0';
						line[y++] = ',';
						line[y++] = ' ';
						b = ((flist[i].date >> 9) & 0x007f) + 1980;
						line[y++] = (b / 1000) + '0';
						b %= 1000;
						line[y++] = (b / 100) + '0';
						b %= 100;
						line[y++] = (b / 10) + '0';
						b %= 10;
						line[y++] = b + '0';
						line[y] = '\0';
						tcolor(LIGHTGREEN);
					} else {
						y = 0;
						b = (flist[i].time >> 11) & 0x001f;
						line[y++] = ' ';
						line[y++] = (b / 10) + '0';
						line[y++] = (b % 10) + '0';
						line[y++] = ':';
						b = ((flist[i].time >> 5) & 0x003f) + unsigned((flist[i].time & 0x001f) / 15);
						line[y++] = (b / 10) + '0';
						line[y++] = (b % 10) + '0';
						line[y] = '\0';
						tcolor(LIGHTRED);
						c_print(line);
						y = 0;
						line[y++] = ' ';
						b = ((flist[i].date >> 5) & 0x000f);
						if (b > 9) line[y++] = (b / 10) + '0';
						else line[y++] = ' ';
						line[y++] = (b % 10) + '0';
						line[y++] = '-';
						b = (flist[i].date & 0x001f);
						line[y++] = (b / 10) + '0';
						line[y++] = (b % 10) + '0';
						line[y++] = '-';
						b = (((flist[i].date >> 9) & 0x007f) + 1980) % 100;
						line[y++] = (b / 10) + '0';
						line[y++] = (b % 10) + '0';
						line[y] = '\0';
						tcolor(LIGHTGREEN);
					}
				}
				if ((len > x) && (DInfo.Columns > 1))
					for (b = 0; b < ((len - x) / 2); b++) line[y++] = ' ';
				line[y] = '\0';
				y = 0;
			} else {
				for (y = 0; y < len; y++)
					line[y] = ' ';
				line[y] = '\0';
			}
			if ((c + 1) % DInfo.Columns) {
				if (i < TList) c_print(line);
				tcolor(CYAN);
				line[y++] = '\xb3';
				line[y] = '\0';
			}
			c_print(line);
		}
	}

	tcolor(tscreen.Oattrib);
	return;
}

void showhelp(void) {

	if (tscreen.columns < 20) {
		c_print("supply path\n");
		c_print("supply opts\n");
		c_print("get a larger\n");
		c_print("screen\n");
		return;
	}
	if (tscreen.columns < 40) {
		c_print("D [path][options]\n");
		c_print(" /o[] sort by\n");
		c_print("       -,n,d,s,e\n");
		c_print(" /d[] directories\n");
		c_print("       -,f,l,m\n");
		c_print(" /# Columns\n");
		c_print(" /a ANSI codes\n");
		c_print(" /b no browse\n");
		c_print(" /c Clear Screen\n");
		c_print(" /l left-Right\n");
		c_print(" /m no color\n");
		c_print(" /r Reverse order\n");
		c_print(" /s Short date/time\n");
		return;
	}
	if (tscreen.columns < 80) {
		c_print("\n");
		tcolor(YELLOW);
		c_print("  Final-D ");
		tcolor(CYAN);
		c_print("(Version ");
		tcolor(RED);
		c_print(_Version_);
		tcolor(CYAN);
		c_print(")\n");
		tcolor(LIGHTCYAN);
		c_print("      By Feeding Dragon, ");
		c_print(__DATE__);c_print("\n");
		tcolor(LIGHTGRAY);
		c_print("usage: D [drv:][pth][file][opts]\n");
		c_print(" /d[] directory placement\n");
		c_print("          f - irst(default) l - last\n");
		c_print("         '-' - don't show   m - mixed\n");
		c_print(" /o[] Sort by\n");
		c_print("        '-' - unsorted (default)\n");
		c_print("         n - name  e - extension\n");
		c_print("         s - size  d - date\n");
		c_print(" /#   Number of Columns\n");
		c_print("      Will downgrade if necessary\n");
		c_print(" /a   Use ANSI codes for color\n");
		c_print(" /b   Disable browse mode\n");
		c_print(" /c   Clear Screen\n");
		c_print(" /l   List left-Right i/o Top-Bottom\n");
		c_print(" /m   Show listing in single color\n");
		c_print(" /r   Reverse the sort order\n");
		c_print(" /s   Use Short Date/Time Only\n");
		tcolor(WHITE);
		c_print(" -Browse with up/down arrow & page keys\n");
		c_print("   ESC to cancel, Spacebar or Return to\n");
		c_print("   continue normally.");
		tcolor(tscreen.Oattrib);
		c_print("\n");
		return;
	}

	c_print("\n");
	tcolor(YELLOW);
	c_print("  Final-D ");
	tcolor(CYAN);
	c_print("(Version ");
	tcolor(LIGHTRED);
	c_print(_Version_);
	tcolor(CYAN);
	c_print(") ");
	tcolor(LIGHTCYAN);
	c_print("By Feeding Dragon, ");
	c_print(__DATE__);c_print("\n");
	tcolor(LIGHTGRAY);
	c_print("\n");
	c_print("usage:  D [drive:][path][filespec][options]\n");
	c_print("   /? /h   brings up this help page\n");
	c_print("   /d[]   Where to place directories\n");
	c_print("           '-' - don't show directories  f - first(default)\n");
	c_print("            l - last  m - In proper sort location\n");
	c_print("   /o[]   Sort Order\n");
	c_print("           '-' - unsorted (default)  n - name  e - extension\n");
	c_print("            s - size  d - date\n");
	c_print("   /#     How many Columns to use\n");
	c_print("            Will automatically downsize if necessary to fit screen\n");
	c_print("   /a     use ANSI codes for color\n");
	c_print("   /b     disable browse/pause mode (mainly for output re-direction\n");
	c_print("   /c     clear the screen before starting display\n");
	c_print("   /l     list left to right instead of top to bottom\n");
	c_print("   /m     show listing in single color only\n");
	c_print("   /r     reverse the order of the files\n");
	c_print("   /s     Do not use long Date/Time format\n");
	tcolor(WHITE);
	c_print(" -Browse with up/down arrow & page keys.  The ESC key cancels the\n");
	c_print("   list, SPACEBAR or ENTER briefly disables browse mode.\n");
	tcolor(tscreen.Oattrib);

	return;
}

void showerr(int x) {

	if (x > -3) printf ("\n");
		else c_print("\n");

	tcolor(YELLOW);
	switch (x) {
		case -1: printf("Screen\nToo\nNarrow");return;
		case -2: printf("Under 5 Rows??\n   Really??");return;
		case -3: c_print("Unknown Switch"); break;
		case -4: c_print("Illegal Path"); break;
		case -5: c_print("Path not found"); break;
		case -6: c_print("Drive not found"); break;
		case -7: c_print("Too Many Files"); break;
		case -9: c_print("Path too Long");break;
		default: c_print("Unknown Error.");
	}

	tcolor(tscreen.Oattrib);
	c_print("\n");

	return;
}

void ShowNoFiles(char *line) {

	char line2[15] = "NO FILES FOUND";
	unsigned i = 0, y = 0, flag = 0, flag2 = 0, flag3 = 0, b = 0, m = 3;

	if (tscreen.columns < 40) --m;
	if (tscreen.columns < 20) --m;

	c_print("\n");

	tcolor(YELLOW);

	while (DInfo.Path[i] != '\0') {
		if (i > 0) for (b = 0; b < m; b++) line[b] = ' ';else b = 0;
		flag = 0; flag2 = 0; flag3 = 0;
		for (y = 0; y < ((unsigned(tscreen.columns) - 2) - b); y++) {
			if (DInfo.Path[i + y] == '\0') {flag = y;y = tscreen.columns;}
			else if (DInfo.Path[i + y] == '\\') flag2 = y;
			else if (DInfo.Path[i + y] == ' ') flag3 = y;
		}
		if (flag2 == 0) flag2 = flag3;
		if (flag == 0) flag = flag2;
		if (flag == 0) flag = y - 1;
		for (y = 0; y < flag; y++) line[b++] = DInfo.Path[i++];
		line[b] = DInfo.Path[i];
		if (DInfo.Path[i] != '\0') {
			line[++b] = '\0';
			++i;
		}
		c_print(line);c_print("\n");
	}

	ShowLine(0,line);c_print("\n");

	tcolor(LIGHTCYAN);
	if (tscreen.columns < 20) {
		for(i = 0; i < ((unsigned(tscreen.columns - 1) / 2) - 4); i++)
			line[i] = ' ';
		for(y = 0; y < 8; y++) line[i++] = line2[y];
		line[i] = '\0';
	} else if (tscreen.columns < 30) {
		for(i = 0; i < ((unsigned(tscreen.columns - 1) / 2) - 7); i++)
			line[i] = ' ';
		for(y = 0; y < 8; y++) {line[i++] = line2[y];line[i++] = ' ';}
		line[i] = '\0';
	} else {
		for(i = 0; i < ((unsigned(tscreen.columns - 1) / 2) - 14); i++)
			line[i] = ' ';
		for(y = 0; y < 14; y++) {line[i++] = line2[y];line[i++] = ' ';}
		line[i] = '\0';
	}
	c_print(line);c_print("\n");

	ShowLine(1,line);c_print("\n");
	ShowLine(3,line);c_print("\n");

	return;
}

void tcolor(char cc) {

	tscreen.Cattrib = (tscreen.Cattrib & 0x70) | (cc & 0x8f);
	return;

}

char gcolor(char *extin) {

	unsigned x = 0, y = 0, z = 0, c = 0;
	char ext[_MAX_EXT] = "";
	char looking = 1, match = 0;
	char color = 0x07;

	const char extlst[]   =    "?C\x02"   "?H\x02"   "?7Z\x0e"  "?AU\x09"  "?DL\x09"  \
			"?GL\x09"  "?GZ\x0e"  "?QT\x09"  "?RM\x09"  "?1ST\x0f" "?3GP\x09" \
			"?AAC\x09" "?AC3\x09" "?ACE\x0e" "?AIF\x09" "?APE\x09" "?ARC\x0e" \
			"?ARJ\x0e" "?ASF\x09" "?ASM\x02" "?AVI\x09" "?BAK\x04" "?BAS\x02" \
			"?BAT\x0c" "?BMP\x05" "?CAB\x0e" "?COM\x0a" "?CPP\x02" "?DIZ\x0f" \
			"?DOC\x0f" "?EXE\x0b" "?FAQ\x0f" "?FLC\x09" "?FLI\x09" "?FLV\x09" \
			"?GIF\x05" "?HPP\x02" "?HTM\x02" "?INC\x0f" "?INI\x0f" "?JPG\x05" \
			"?KEY\x0f" "?LBM\x05" "?MOD\x09" "?MOV\x09" "?MP3\x09" "?MP4\x09" \
			"?MPG\x09" "?NEW\x0f" "?NFO\x0f" "?NOW\x0f" "?OGG\x09" "?OGM\x09" \
			"?OLD\x04" "?PAK\x0e" "?PAR\x0e" "?PAS\x02" "?PCM\x09" "?PCX\x05" \
			"?PIC\x05" "?PNG\x05" "?RAR\x0e" "?REG\x0f" "?RMV\x09" "?S7Z\x0e" \
			"?SEA\x0e" "?SFV\x0e" "?SFX\x0e" "?SID\x09" "?SIT\x0e" "?SND\x09" \
			"?SWP\x04" "?TAR\x0e" "?TEM\x04" "?TMP\x04" "?TXT\x0f" "?UHA\x0e" \
			"?VOC\x09" "?vox\x09" "?WAV\x09" "?WMA\x09" "?WMV\x09" "?XMI\x09" \
			"?ZIP\x0e" "?ZOO\x0e" ;

	if (extin[0] == '\0') return(color & 0x8F);

	while ((extin[z] != '\0') && (z < (_MAX_EXT - 1))) if ((extin[z] > 96) && (extin[z] < 123)) ext[z] = extin[z++] - 32;
	else ext[z] = extin[z++];
	ext[z] = '/0';

	while (looking) {
		y = x + 1;
		while ((extlst[y] != '?') && (extlst[y] != '\0')) ++y;
		if ((y - x) == (z + 2)) {
			for (c = 0; c < z; c ++) if (ext[c] == extlst[x + c + 1]) match = 1;
			else {match = 0; c = z;}
			if (match) {
				looking = 0;
				color = extlst[x + c + 1];
			}
		}
		if (extlst[y] == '\0') looking = 0;
		else x = y;
	}

	return(color & 0x8F);
}

void textval(char* s,unsigned long sh,unsigned long sl,int z) {

	unsigned long fl = 0;
	unsigned long fh = 0;
	char sen[7] = " bytes";
	int x = 1, y = 6, i = 0, c = 0, b, flag = 0;

	if (((sh * 4) + (sl / _GB_)) >= 1000) {
		sen[1] = 'T';sen[2] = 'B';sen[3] = '\n';y = 3;
		fh = sh / 256;
		fl = ((sh % 256) * 4) + (sl / _GB_);
		sl %= _GB_;
		fl *= 1000;
		sl = (((sl / 1024) * 1000) / _MB_);
		fl = (((sl + fl) * 1000) / 1024);
	} else if ((sh > 0) || (sl >= 1000000000)) {
		sen[1] = 'G';sen[2] = 'B';sen[3] = '\n';y = 3;
		fh = (sh * 4) + (sl / _GB_);
		sl %= _GB_;
		fl = (sl / _MB_) * 1000;
		sl %= _MB_;
		sl = (((sl / 1024) * 1000) / 1024);
		fl = (((sl + fl) * 1000) / 1024);
	} else if (sl >= 1000000) {
		sen[1] = 'M';sen[2] = 'B';sen[3] = '\n';y = 3;
		fh = sl / _MB_;
		sl %= _MB_;
		fl = ((sl / 1024) * 1000);
		sl %= 1024;
		sl = ((sl * 1000) / 1024);
		fl = ((sl + fl) * 1000) / 1024;
	} else if (sl >= 1000) {
		sen[1] = 'K';sen[2] = 'B';sen[3] = '\n';y = 3;
		fh = sl / 1024;
		sl %= 1024;
		fl = ((sl * 1000000) / 1024);
	} else {
		fh = sl;
		fl = 0;

	}


	if (fh > 99) ++x;
	if (fh > 9) ++x;

	c = (z - y) - x;
	if (c < 0) {for (c = 1; c < (z - 1); c++) s[c] = '?';s[0] = ' ';s[c] = '\0';return;}

	switch (c--) {
		case 0:
		case 1: fl = 0; break;
		case 2: fl = (fl + 50000) / 100000;
			if (fl == 10) {++fh; fl = 0;}
			break;
		case 3: fl = (fl + 5000) / 10000;
			if (fl == 100) {++fh; fl = 0;}
			break;
		case 4: fl = (fl + 500) / 1000;
			if (fl == 1000) {++fh; fl = 0;}
			break;
		case 5: fl = (fl + 50) / 100;
			if (fl == 10000) {++fh; fl = 0;}
			break;
		case 6: fl = (fl + 5) / 10;
			if (fl == 100000) {++fh; fl = 0;}
			break;
	}

	if ((fl > 0) && ((x + y + 1) < z)) {
		if (fl > 9999) ++i;
		if (fl > 999) ++i;
		if (fl > 99) ++i;
		if (fl > 9) ++i;
		if (fl > 0) ++i;
	} else c = 0;

	if ((fl % 10) == 0) fl /= 10;
	if ((fl % 10) == 0) fl /= 10;
	if ((fl % 10) == 0) fl /= 10;
	if ((fl % 10) == 0) fl /= 10;
	if ((fl % 10) == 0) fl /= 10;

	flag = 0;
	if (c == 0) for (b = 0; b < (z - (x + y)); b++) s[flag++] = ' ';
	else for (b = 0; b < (z - (x + y + 1 + c)); b++) s[flag++] = ' ';
	if (fh > 99) s[flag++] = char(fh / 100) + '0';
	if (fh > 9) s[flag++] = char((fh % 100) / 10) + '0';
	s[flag++] = (fh % 10) + '0';

	if (c > 0) {
		s[flag++] = '.';
		for (b = i; b < c; b++) s[flag++] = '0';
		if (fl > 9999) s[flag++] = char(fl / 10000) + '0';
		if (fl > 999) s[flag++] = char((fl % 10000) / 1000) + '0';
		if (fl > 99) s[flag++] = char((fl % 1000) / 100) + '0';
		if (fl > 9) s[flag++] = char((fl % 100) / 10) + '0';
		s[flag++] = char(fl % 10) + '0';
	}
	for (b = 0; b < y; b++) s[flag++] = sen[b];
	s[flag] = '\0';

	return;
}

void sortlist(void) {

	unsigned i = 0, c = 0;
	file_list sorting;

	if ((bgiven.dplace & 3) < 2)
		for (i = 0; i < (TList - 1); i++)
			for (c = i + 1; c < TList; c++)
				if ((!((flist[i].attrib & _A_SUBDIR) == _A_SUBDIR) ^ ((bgiven.dplace & 3) == 1)) \
					&& (((flist[c].attrib & _A_SUBDIR) == _A_SUBDIR) ^ ((bgiven.dplace & 3) == 1))) \
				{
					sorting = flist[i];
					flist[i] = flist[c];
					flist[c] = sorting;
				}
	if ((bgiven.sort & 7) == 0) {
		if (bgiven.reverse & 1)
			for (i = 0; i < (TList / 2); i++) {
				sorting = flist[i];
				flist[i] = flist[(TList - 1) - i];
				flist[(TList - 1) - i] = sorting;
			}
		return;
	}

	if ((bgiven.dplace & 3) == 1) {
		for (i = 0; i < (DInfo.TFiles - 1); i++)
			for (c = i + 1; c < DInfo.TFiles; c++)
				qswap(i,c);
		for (i = DInfo.TFiles; i < (TList - 1); i++)
			for (c = i + 1; c < TList; c++)
				qswap(i,c);
	} else if ((bgiven.dplace & 3) == 0) {
		for (i = 0; i < (DInfo.TDirectories - 1); i++)
			for (c = i + 1; c < DInfo.TDirectories; c++)
				qswap(i,c);
		for (i = DInfo.TDirectories; i < (TList - 1); i++)
			for (c = i + 1; c < TList; c++)
				qswap(i,c);
	} else for (i = 0; i < (TList - 1); i++)
			for (c = i + 1; c < TList; c++)
				qswap(i,c);

	return;
}

void qswap(unsigned i, unsigned c) {

	unsigned x = 0, z = 0, y = 0;
	unsigned long ultem = 0;
	char method1[13], method2[13];
	file_list sorting;

	switch (bgiven.sort & 7) {
		case 1: for (x = 0; x < 9; x++) if (flist[i].name[x] != '\0') method1[x] = flist[i].name[x];
			else {ultem = x;x = 9;}
			method1[ultem++] = '.';
			for (x = 0; x < 4; x++) if (flist[i].ext[x] != '\0') method1[ultem++] = flist[i].ext[x];
			else x = 4;
			method1[ultem] = '\0';
			for (x = 0; x < 9; x++) if (flist[c].name[x] != '\0') method2[x] = flist[c].name[x];
			else {ultem = x;x = 9;}
			method2[ultem++] = '.';
			for (x = 0; x < 4; x++) if (flist[c].ext[x] != '\0') method2[ultem++] = flist[c].ext[x];
			else x = 4;
			method2[ultem] = '\0';
			break;
		case 2:
			for (x = 0; x < 4; x++) if (flist[i].ext[x] != '\0') method1[x] = flist[i].ext[x];
			else {ultem = x;x = 4;}
			method1[ultem++] = '.';
			for (x = 0; x < 9; x++) if (flist[i].name[x] != '\0') method1[ultem++] = flist[i].name[x];
			else x = 9;
			if (ultem < 12) method1[ultem++] = '.';
			method1[ultem] = '\0';
			for (x = 0; x < 4; x++) if (flist[c].ext[x] != '\0') method2[x] = flist[c].ext[x];
			else {ultem = x;x = 4;}
			method2[ultem++] = '.';
			for (x = 0; x < 9; x++) if (flist[c].name[x] != '\0') method2[ultem++] = flist[c].name[x];
			else x = 9;
			if (ultem < 12) method2[ultem++] = '.';
			method2[ultem] = '\0';
			break;
		case 3:	ultem = flist[i].size;
			method1[8] = '\0';
			for (x = 0; x < 8; x++) {
				y = ultem & 0x0000000f;
				if (y > 9) y += 7;
				method1[7 - x] = y + '0';
				ultem = (ultem >> 4);
			}
			ultem = flist[c].size;
			method2[8] = '\0';
			for (x = 0; x < 8; x++) {
				y = ultem & 0x0000000f;
				if (y > 9) y += 7;
				method2[7 - x] = y + '0';
				ultem = (ultem >> 4);
			}
			break;
		case 4:	z = flist[i].date;
			method1[8] = '\0';
			for (x = 0; x < 4; x++) {
				y = z & 0x000f;
				if (y > 9) y += 7;
				method1[3 - x] = y + '0';
				z = z >> 4;
			}
			z = flist[i].time;
			for (x = 0; x < 4; x++) {
				y = z & 0x000f;
				if (y > 9) y += 7;
				method1[7 - x] = y + '0';
				z = z >> 4;
			}
			z = flist[c].date;
			method2[8] = '\0';
			for (x = 0; x < 4; x++) {
				y = z & 0x000f;
				if (y > 9) y += 7;
				method2[3 - x] = y + '0';
				z = z >> 4;
			}
			z = flist[c].time;
			for (x = 0; x < 4; x++) {
				y = z & 0x000f;
				if (y > 9) y += 7;
				method2[7 - x] = y + '0';
				z = z >> 4;
			}
			break;
	}
	if ((strcmpi(method1,method2) > 0) ^ (bgiven.reverse & 1)) {
		sorting = flist[i];
		flist[i] = flist[c];
		flist[c] = sorting;
	}
	
	return;
}