#include "globals.h"
#include <stdio.h>
#include <string.h>
#include <conio.h>

unsigned huge *ptr;
char huge *ptrb;

void scurs(unsigned x) {

	if (x == 0) _setcursortype(_NOCURSOR);
	if (x == 1) _setcursortype(_NORMALCURSOR);

	return;
}

int getcur(void) {

	unsigned rc = 0;
	unsigned char ccol = '\0', crow = '\0', dev = '\0';

	ptr = (unsigned huge *)0x0040004a;
	tscreen.columns = *ptr;


	if (tscreen.columns < 13) return(-1);

	ptrb = (char huge *)0x00400084;
	tscreen.rows = *ptrb + 1;

	if (tscreen.rows < 5) return(-2);

	ptrb = (char huge *)0x00400010;
	dev = (*ptrb & 0x30);
	if (dev == 0x30) tscreen.segment = 0xB000;
		else tscreen.segment = 0xB800;

	ptrb = (char huge *)0x00400062;
	tscreen.screen = *ptrb;
	ptr = (unsigned huge *)0x0040004e;
	tscreen.offset = *ptr;

	ptr = (unsigned huge *)(0x00400050 + (tscreen.screen * 2));
	rc = *ptr;
	ccol = (rc & 0x00ff);
	crow = ((rc >> 8) & 0x00ff);

	ptrb = (char huge *)((((unsigned long)tscreen.segment << 16) & 0xFFFF0000) \
		+ (crow * (tscreen.columns * 2)) + (ccol * 2) + tscreen.offset + 1);
	tscreen.Oattrib = *ptrb;
	tscreen.Cattrib = tscreen.Oattrib;

	return(0);
}

void sclear(void) {

	int i = 0;
	unsigned x = (unsigned)(((tscreen.Cattrib << 8) & 0xff00) + 0x20);

	for (i = 0; i < (tscreen.rows * tscreen.columns); i++) {
		ptr = (unsigned huge *)((((unsigned long)tscreen.segment << 16) & 0xFFFF0000) \
			+ tscreen.offset + (i * 2));
		*ptr = x;
	}
	ptr = (unsigned huge *)(0x00400050 + (tscreen.screen * 2));
	*ptr = 0x0000;

	return;
}

void c_print(char *x) {

	int i = 0;
	unsigned rc = 0;
	unsigned char crow = 0, ccol = 0;
	char dansi[16] = "";

	if (bgiven.dcolor) printf(x);

	else if (bgiven.dansi) {
		crow = tscreen.Cattrib;

		strcpy(dansi,"\x1b[37;40");
		if (crow & 0x80) strcat(dansi,";5");
		if (crow & 0x08) strcat(dansi,";1");
		strcat(dansi,"m");

		ccol = (crow >> 4) & 0x07;
		crow &= 0x07;

		if (ccol == 1) ccol = 4;
			else if (ccol == 4) ccol = 1;
		if (ccol == 3) ccol = 6;
			else if (ccol == 6) ccol = 3;
		if (crow == 1) crow = 4;
			else if (crow == 4) crow = 1;
		if (crow == 3) crow = 6;
			else if (crow == 6) crow = 3;

		dansi[6] = char(ccol) + '0';
		dansi[3] = char(crow) + '0';

		printf(dansi);
		printf(x);

		printf("\x1b[0m");

	} else {
		ptr = (unsigned huge *)(0x00400050 + (tscreen.screen * 2));
		rc = *ptr;
		crow = char((rc >> 8) & 0x00ff);
		ccol = char(rc & 0x00ff);

		for (i = 0; i < strlen(x); i++) {
			if ((x[i] != char(9)) && (x[i] != char(7)) && (x[i] != char(8)) \
				&& (x[i] != char(10)) && (x[i] != char(13))) {
				putchar(x[i]);
				ptrb = (char huge *)((((unsigned long)tscreen.segment << 16) & 0xFFFF0000) \
					+ (crow * (tscreen.columns * 2)) + (ccol * 2) + tscreen.offset + 1);
				*ptrb = tscreen.Cattrib;
			} else putchar(x[i]);
			ptr = (unsigned huge *)(0x00400050 + (tscreen.screen * 2));
			rc = *ptr;
			crow = char((rc >> 8) & 0x00ff);
			ccol = char(rc & 0x00ff);
		}


		ptrb = (char huge *)((((unsigned long)tscreen.segment << 16) & 0xFFFF0000) \
			+ (crow * (tscreen.columns * 2)) + (ccol * 2) + tscreen.offset + 1);
		*ptrb = tscreen.Oattrib;
	}

	return;
}

void scrlback(void) {

	unsigned i = 0;

	for (i = (tscreen.rows - 2); i > 0; i--)
		movedata(tscreen.segment,((i - 1) * unsigned(tscreen.columns) * 2) + tscreen.offset, \
		tscreen.segment,(i * unsigned(tscreen.columns) * 2) + tscreen.offset, \
		unsigned(tscreen.columns) * 2);
	for(i = 0; i < unsigned(tscreen.columns); i++) {
		ptr = (unsigned huge *)((((unsigned long)tscreen.segment << 16) & 0xFFFF0000) \
			+ (i * 2) + tscreen.offset);
		*ptr = (unsigned)(((tscreen.Cattrib << 8) & 0xff00) + 0x20);
	}
	ptr = (unsigned huge *)(0x00400050 + (tscreen.screen * 2));
	*ptr = 0x0000;

	return;
}

void scrlfor(void) {

	unsigned i = 0;

	for (i = 1; i < (tscreen.rows - 1); i++)
		movedata(tscreen.segment,(i * unsigned(tscreen.columns) * 2) + tscreen.offset, \
		tscreen.segment,((i - 1) * unsigned(tscreen.columns) * 2) + tscreen.offset, \
		unsigned(tscreen.columns) * 2);
	for(i = 0; i < unsigned(tscreen.columns); i++) {
		ptr = (unsigned huge *)((((unsigned long)tscreen.segment << 16) & 0xFFFF0000) + \
			((tscreen.rows - 2) * unsigned(tscreen.columns) * 2) + \
			(i * 2) + tscreen.offset);
		*ptr = (unsigned)(((tscreen.Cattrib << 8) & 0xff00) + 0x20);
	}
	ptr = (unsigned huge *)(0x00400050 + (tscreen.screen * 2));
	*ptr = ((tscreen.rows - 2) << 8) & 0xff00;

	return;
}

void lastrow(void) {

	ptr = (unsigned huge *)((0x00400050) + (tscreen.screen * 2));
	*ptr = ((tscreen.rows - 1) << 8) & 0xff00;

	return;
}

void ClearLine(void) {

	unsigned i = 0, rc = 0;
	char crow = 0;
	
	ptr = (unsigned huge *)(0x00400050 + (tscreen.screen * 2));
	rc = *ptr;
	crow = char((rc >> 8) & 0x00ff);

	for(i = 0; i < tscreen.columns; i++) {
		ptr = (unsigned huge *)((((unsigned long)tscreen.segment << 16) & 0xFFFF0000) \
			+ (crow * tscreen.columns * 2) + (i * 2) + tscreen.offset);
		*ptr = ((((unsigned)tscreen.Cattrib << 8) & 0xff00) + 0x20);
	}

	ptr = (unsigned huge *)(0x00400050 + (tscreen.screen * 2));
	rc &= 0xff00;
	*ptr = rc;

	return;
}